package org.appfuse.web;

import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.appfuse.model.User;
import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;
import org.dom4j.io.DOMWriter;
import org.springframework.web.servlet.view.xslt.AbstractXsltView;
import org.w3c.dom.Node;

public class UserXMLView extends AbstractXsltView {
    protected Node createDomNode(Map model, String rootName,
                                 HttpServletRequest request,
                                 HttpServletResponse response)
    throws Exception {
        Document doc = DocumentHelper.createDocument();
        Element root = doc.addElement(rootName);
        doc.setRootElement(root);
        
        List users = (List) model.get("users");
        for (Iterator it = users.iterator(); it.hasNext();) {
            User user = (User) it.next();
            root.addElement("user").addText(user.getFullName());
        }
        
        response.setContentType("text/xml");
        
        return new DOMWriter().write(doc);
    }
}
